Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weka.filters.supervised.attribute
Class NominalToBinary

    java.lang.Object
      weka.filters.Filter
          weka.filters.supervised.attribute.NominalToBinary

All Implemented Interfaces:
  java.io.Serializable, CapabilitiesHandler, OptionHandler, RevisionHandler, TechnicalInformationHandler, SupervisedFilter

    public class NominalToBinary

extends Filter
implements SupervisedFilter, OptionHandler, TechnicalInformationHandler

Converts all nominal attributes into binary numeric attributes. An attribute with k values is transformed into k binary attributes if the class is nominal (using the one-attribute-per-value approach). Binary attributes are left binary, if option '-A' is not given.If the class is numeric, k - 1 new binary attributes are generated in the manner described in "Classification and Regression Trees" by Breiman et al. (i.e. taking the average class value associated with each attribute value into account)
For more information, see:
L. Breiman, J.H. Friedman, R.A. Olshen, C.J. Stone (1984). Classification and Regression Trees. Wadsworth Inc.

BibTeX:

     @book{Breiman1984,
        author = {L. Breiman and J.H. Friedman and R.A. Olshen and C.J. Stone},
        publisher = {Wadsworth Inc},
        title = {Classification and Regression Trees},
        year = {1984},
        ISBN = {0412048418}
     }

Valid options are:

     -N
      Sets if binary attributes are to be coded as nominal ones.

     -A
      For each nominal value a new attribute is created,
      not only if there are more than 2 values.

Version:
  $Revision: 5541 $
Author:
  Eibe Frank (eibe@cs.waikato.ac.nz)
See Also:
  Serialized Form

Constructor Summary
`NominalToBinary()`

Method Summary
`boolean` | `batchFinished()` Signify that this batch of input to the filter is finished.
`java.lang.String` | `binaryAttributesNominalTipText()` Returns the tip text for this property
`boolean` | `getBinaryAttributesNominal()` Gets if binary attributes are to be treated as nominal ones.
`Capabilities` | `getCapabilities()` Returns the Capabilities of this filter.
`java.lang.String[]` | `getOptions()` Gets the current settings of the filter.
`java.lang.String` | `getRevision()` Returns the revision string.
`TechnicalInformation` | `getTechnicalInformation()` Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.
`boolean` | `getTransformAllValues()` Gets if all nominal values are turned into new attributes, not only if there are more than 2.
`java.lang.String` | `globalInfo()` Returns a string describing this filter
`boolean` | `input(Instance instance)` Input an instance for filtering.
`java.util.Enumeration` | `listOptions()` Returns an enumeration describing the available options.
`static void` | `main(java.lang.String[] argv)` Main method for testing this class.
`void` | `setBinaryAttributesNominal(boolean bool)` Sets if binary attributes are to be treates as nominal ones.
`boolean` | `setInputFormat(Instances instanceInfo)` Sets the format of the input instances.
`void` | `setOptions(java.lang.String[] options)` Parses a given list of options.
`void` | `setTransformAllValues(boolean bool)` Sets whether all nominal values are transformed into new attributes, not just if there are more than 2.
`java.lang.String` | `transformAllValuesTipText()` Returns the tip text for this property

Methods inherited from class weka.filters.Filter
`batchFilterFile, filterFile, getCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, numPendingOutput, output, outputPeek, toString, useFilter, wekaStaticWrapper`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### NominalToBinary

    public NominalToBinary()

Method Detail

### globalInfo

    public java.lang.String globalInfo()

  Returns a string describing this filter

  Returns:
    a description of the filter suitable for displaying in the explorer/experimenter gui

### getTechnicalInformation

    public TechnicalInformation getTechnicalInformation()

  Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.

  Specified by:
    `getTechnicalInformation` in interface `TechnicalInformationHandler`
  Returns:
    the technical information about this class

### getCapabilities

    public Capabilities getCapabilities()

  Returns the Capabilities of this filter.

  Specified by:
    `getCapabilities` in interface `CapabilitiesHandler`
  Overrides:
    `getCapabilities` in class `Filter`
  Returns:
    the capabilities of this object
  See Also:
    `Capabilities`

### setInputFormat

    public boolean setInputFormat(Instances instanceInfo)
                           throws java.lang.Exception

  Sets the format of the input instances.

  Overrides:
    `setInputFormat` in class `Filter`
  Parameters:
    `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
  Returns:
    true if the outputFormat may be collected immediately
  Throws:
    `java.lang.Exception` - if the input format can't be set successfully

### input

    public boolean input(Instance instance)

  Input an instance for filtering. Filter requires all training instances be read before producing output.

  Overrides:
    `input` in class `Filter`
  Parameters:
    `instance` - the input instance
  Returns:
    true if the filtered instance may now be collected with output().
  Throws:
    `java.lang.IllegalStateException` - if no input format has been set

### batchFinished

    public boolean batchFinished()

  Signify that this batch of input to the filter is finished. If the filter requires all instances prior to filtering, output() may now be called to retrieve the filtered instances.

  Overrides:
    `batchFinished` in class `Filter`
  Returns:
    true if there are instances pending output
  Throws:
    `java.lang.IllegalStateException` - if no input structure has been defined

### listOptions

    public java.util.Enumeration listOptions()

  Returns an enumeration describing the available options.

  Specified by:
    `listOptions` in interface `OptionHandler`
  Returns:
    an enumeration of all the available options.

### setOptions

    public void setOptions(java.lang.String[] options)
                    throws java.lang.Exception

  Parses a given list of options.

  Valid options are:

       -N
        Sets if binary attributes are to be coded as nominal ones.

       -A
        For each nominal value a new attribute is created,
        not only if there are more than 2 values.

  Specified by:
    `setOptions` in interface `OptionHandler`
  Parameters:
    `options` - the list of options as an array of strings
  Throws:
    `java.lang.Exception` - if an option is not supported

### getOptions

    public java.lang.String[] getOptions()

  Gets the current settings of the filter.

  Specified by:
    `getOptions` in interface `OptionHandler`
  Returns:
    an array of strings suitable for passing to setOptions

### binaryAttributesNominalTipText

    public java.lang.String binaryAttributesNominalTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### getBinaryAttributesNominal

    public boolean getBinaryAttributesNominal()

  Gets if binary attributes are to be treated as nominal ones.

  Returns:
    true if binary attributes are to be treated as nominal ones

### setBinaryAttributesNominal

    public void setBinaryAttributesNominal(boolean bool)

  Sets if binary attributes are to be treates as nominal ones.

  Parameters:
    `bool` - true if binary attributes are to be treated as nominal ones

### transformAllValuesTipText

    public java.lang.String transformAllValuesTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### getTransformAllValues

    public boolean getTransformAllValues()

  Gets if all nominal values are turned into new attributes, not only if there are more than 2.

  Returns:
    true all nominal values are transformed into new attributes

### setTransformAllValues

    public void setTransformAllValues(boolean bool)

  Sets whether all nominal values are transformed into new attributes, not just if there are more than 2.

  Parameters:
    `bool` - true if all nominal value are transformed into new attributes

### getRevision

    public java.lang.String getRevision()

  Returns the revision string.

  Specified by:
    `getRevision` in interface `RevisionHandler`
  Overrides:
    `getRevision` in class `Filter`
  Returns:
    the revision

### main

    public static void main(java.lang.String[] argv)

  Main method for testing this class.

  Parameters:
    `argv` - should contain arguments to the filter: use -h for help

Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD